/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package model2;

import generated.ObjectFactory;
import generated.Produkt;
import generated.Warenkorb;
import java.io.File;
import java.math.BigInteger;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Marshaller;

/**
 *
 * @author micha
 */
public class XMLZugriff {

    private ObjectFactory objF;
    private Produkt produkt;

    public XMLZugriff() {
        objF = new generated.ObjectFactory();
    }

    public List deSerializeProduktliste() {

        List<generated.Produkt.Row> produktListe = null;

        try {
            //unmarshaller erzeugen und xml nach objekt deserialisieren
            JAXBContext context = JAXBContext.newInstance(Produkt.class);
            Unmarshaller u = context.createUnmarshaller();

            Produkt produkteNeu
                    = (Produkt) u.unmarshal(new File("xmlUndXsd/katalog.xml"));

            //liste fuellen
            produktListe = produkteNeu.getRow();

        } catch (Exception e) {
            e.printStackTrace();
        }

        return produktListe;
    }

    public void serializeWarenkorb(Warenkorb warenkorb) {
        //marshaller erzeugen und serialisieren
        try {
            // create JAXB context and instantiate marshaller

            JAXBContext context = JAXBContext.newInstance(generated.Warenkorb.class);

            Marshaller m = context.createMarshaller();
            m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);

            // Write to System.out
            m.marshal(warenkorb, System.out);

            // Write to File
            m.marshal(warenkorb, new File("/tmp/warenkorb.xml"));

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    ArrayList<String> getHerstellerListe(){
        ArrayList<String> herstellerListe = new ArrayList();
        List<Produkt.Row> produkte = this.deSerializeProduktliste();

        for (Produkt.Row zeile : produkte) {
            herstellerListe.add(zeile.getHersteller());
        }

        return herstellerListe;

    }

     ArrayList<model2.Produkt> getProduktListe(String hersteller) throws Exception {
        model2.Produkt produkt;
        ArrayList<model2.Produkt> produktListe = new ArrayList();

        
        ^while (rs.next()) {
            produkt = new model2.Produkt();
            produkt.setArt_nr(rs.getString("art_nr"));
            produkt.setProduktname(rs.getString("produktname"));
            produkt.setBeschreibung(rs.getString("beschreibung"));
            produkt.setHersteller(rs.getString("hersteller"));
            produkt.setPreis(rs.getInt("preis"));
            produkt.setImg_name(rs.getString("img_name"));
            produkt.setImg_pfad(rs.getString("img_pfad"));
            produkt.setBestand(rs.getInt("bestand"));
            produktListe.add(produkt);
        }
        rs.close();
        ps.close();
        return produktListe;
    }
    
    public static void main(String[] args) {
        XMLZugriff xmlz = new XMLZugriff();
        List<Produkt.Row> produkte = xmlz.deSerializeProduktliste();

        System.out.println("" + ""
                + "art_nr\t"
                + "produktname\t"
                + "beschreibung\t"
                + "hersteller\t"
                + "preis\t"
                + "img_name\t"
                + "img_pfad\t"
                + "bestand");

        for (Produkt.Row zeile : produkte) {

            System.out.printf("%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\n",
                    zeile.getArtNr(),
                    zeile.getProduktname(),
                    zeile.getBeschreibung(),
                    zeile.getHersteller(),
                    zeile.getPreis(),
                    zeile.getImgName(),
                    zeile.getImgPfad(),
                    zeile.getBestand()
            );

        }

        Warenkorb warenkorb = new Warenkorb();

        warenkorb.setName("neumann");
        warenkorb.setVname("alfred e.");
        warenkorb.setAdresse("madboulevard 1a, 79098 freiburg");
        List positionen = warenkorb.getPosition();

        Warenkorb.Position position = new Warenkorb.Position();
        position.setArtNr("art_1234");
        position.setProduktname("madheft20160923");
        position.setStueckzahl(new BigInteger("1"));
        positionen.add(position);

        xmlz.serializeWarenkorb(warenkorb);

        for(String item : xmlz.getHerstellerListe()){
            System.out.println("herstelle: "+item);
        }
        
    }

}
